extern crate proc_macro;
use proc_macro::TokenStream;
use quote::quote;
use syn::{parse_macro_input, LitStr};

/// This macro is used to get the environment variable prefixed with the `ENV_LEAD_PREFIX` environment variable.
/// If `ENV_LEAD_PREFIX` is not set, it will default to `ENV`. The given string will be converted to uppercase.
#[proc_macro]
pub fn envhead(input: TokenStream) -> TokenStream {
    let prefix = option_env!("ENV_HEAD_PREFIX").unwrap_or("ENV");
    let input = parse_macro_input!(input as LitStr);
    let value = input.value();
    let upper_value = format!("{}_{}", prefix.to_uppercase(), value.to_uppercase());
    let expanded = quote! {
        #upper_value
    };

    TokenStream::from(expanded)
}
